/*
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */


#ifndef _controllereditor_
#define _controllereditor_

#include "Editors/Editor.h"

#include <vector>

namespace AriaMaestosa {
	
class Track; // forward
class ControllerChoice;

class ControllerEditor : public Editor
{
    
	bool hasBeenResizing; // true if user has been resizing track anytime since last mouse down
    bool dragging_on_track; // true if mouse drag is within track bounds. false if is on header on scrollbar, etc.

    ControllerChoice* controllerChoice;
    
    int selection_begin, selection_end;
public:

    ControllerEditor(Track* track);
    
    void render(int mousex_current=-1, int mousey_current=-1, int mousex_initial=-1, int mousey_initial=-1, bool focus=false);
    
    void selectAll( bool selected );
    
    void updatePosition(const int from_y, const int to_y, const int width, const int height, const int barHeight);
    
    void mouseDown(const int x, const int y);
    void mouseDrag(const int mousex_current, const int mousey_current, const int mousex_initial, const int mousey_initial);
    void mouseUp(const int mousex_current, int mousey_current, const int mousex_initial, int mousey_initial);
    void rightClick(const int x, const int y);
    
    int getSelectionBegin();
    int getSelectionEnd();
    
	int getCurrentControllerType();
	
    int getYScrollInPixels();
    
    ~ControllerEditor();
};

}

#endif
